
_main:
;lights_mikroc.c,175 :: 		void main (void)
;lights_mikroc.c,177 :: 		Init();                             // Init periphery
	CALL       _Init+0
;lights_mikroc.c,179 :: 		OS_Init();                          // Init OS
	CALL       _OS_Init+0
;lights_mikroc.c,181 :: 		OS_Task_Create(0, Task_Rolling);    // Create tasks.
	CLRF       FARG__OS_Task_Create_priority+0
	MOVLW      _Task_Rolling+0
	MOVWF      FARG__OS_Task_Create_TaskAddr+0
	MOVLW      hi_addr(_Task_Rolling+0)
	MOVWF      FARG__OS_Task_Create_TaskAddr+1
	CALL       __OS_Task_Create+0
;lights_mikroc.c,182 :: 		OS_Task_Create(0, Task_SetSpeed);   //
	CLRF       FARG__OS_Task_Create_priority+0
	MOVLW      _Task_SetSpeed+0
	MOVWF      FARG__OS_Task_Create_TaskAddr+0
	MOVLW      hi_addr(_Task_SetSpeed+0)
	MOVWF      FARG__OS_Task_Create_TaskAddr+1
	CALL       __OS_Task_Create+0
;lights_mikroc.c,183 :: 		OS_Task_Create(0, Task_Button);     //
	CLRF       FARG__OS_Task_Create_priority+0
	MOVLW      _Task_Button+0
	MOVWF      FARG__OS_Task_Create_TaskAddr+0
	MOVLW      hi_addr(_Task_Button+0)
	MOVWF      FARG__OS_Task_Create_TaskAddr+1
	CALL       __OS_Task_Create+0
;lights_mikroc.c,186 :: 		m_cPosition  = 0;                   // rotation phase
	CLRF       _m_cPosition+0
;lights_mikroc.c,187 :: 		m_cDirection = 1;                   // dircetion
	MOVLW      1
	MOVWF      _m_cDirection+0
;lights_mikroc.c,189 :: 		OS_EI();                            // Enable interrupts
	BSF        GIE_bit+0, 7
;lights_mikroc.c,191 :: 		OS_Run();                           // Running scheduler
L_main0:
	CLRF       __OS_temp+0
	MOVLW      _OS_TaskVars+0
	MOVWF      R0+0
	MOVLW      10
	ADDWF      R0+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	SUBWF      __OS_CurTask+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_main3
	MOVLW      _OS_TaskVars+0
	MOVWF      __OS_CurTask+0
	GOTO       L_main4
L_main3:
	MOVLW      5
	ADDWF      __OS_CurTask+0, 1
L_main4:
	CALL       ___OS_SET_FSR_CUR_TASK+0
	BTFSS      __indf+0, 6
	GOTO       L__main41
	BTFSC      __indf+0, 7
	GOTO       L__main41
	GOTO       L_main7
L__main41:
	GOTO       ___main__LABEL_SCHED_CONTINUE
L_main7:
	BTFSS      __indf+0, 4
	GOTO       L_main10
	BTFSC      __indf+0, 5
	GOTO       L_main10
L__main40:
	GOTO       ___main__LABEL_SCHED_CONTINUE
L_main10:
	CALL       ___OS_JumpToTask+0
	CLRF       __status+0
___main__LABEL_SCHED_CONTINUE:
	GOTO       L_main0
;lights_mikroc.c,193 :: 		}
	GOTO       $+0
; end of _main

_Init:
;lights_mikroc.c,214 :: 		void Init (void)
;lights_mikroc.c,221 :: 		PORTA = PORTA_CONST;
	CLRF       PORTA+0
;lights_mikroc.c,222 :: 		PORTB = PORTB_CONST;
	CLRF       PORTB+0
;lights_mikroc.c,224 :: 		TRISA = TRISA_CONST;
	MOVLW      1
	MOVWF      TRISA+0
;lights_mikroc.c,225 :: 		TRISB = TRISB_CONST;
	MOVLW      1
	MOVWF      TRISB+0
;lights_mikroc.c,227 :: 		NOT_RBPU_bit = 0;
	BCF        NOT_RBPU_bit+0, 7
;lights_mikroc.c,229 :: 		PORTC = PORTC_CONST;
	CLRF       PORTC+0
;lights_mikroc.c,230 :: 		TRISC = TRISC_CONST;
	CLRF       TRISC+0
;lights_mikroc.c,234 :: 		PORTD = PORTD_CONST;
	CLRF       PORTD+0
;lights_mikroc.c,235 :: 		TRISD = TRISD_CONST;
	CLRF       TRISD+0
;lights_mikroc.c,239 :: 		PORTE = PORTE_CONST;
	CLRF       PORTE+0
;lights_mikroc.c,240 :: 		TRISE = TRISE_CONST;
	CLRF       TRISE+0
;lights_mikroc.c,248 :: 		ADCON0 = 0xC1;                  // Channel 0
	MOVLW      193
	MOVWF      ADCON0+0
;lights_mikroc.c,252 :: 		ADCON1 = 0x0E;                  // Use only one analog input AN0 (RA0)
	MOVLW      14
	MOVWF      ADCON1+0
;lights_mikroc.c,264 :: 		OPTION_REG = 0x00 | T0CON_CONST;
	MOVLW      65
	MOVWF      OPTION_REG+0
;lights_mikroc.c,267 :: 		T2CON = T2CON_CONST;
	MOVLW      37
	MOVWF      T2CON+0
;lights_mikroc.c,268 :: 		PR2 = 250-1;
	MOVLW      249
	MOVWF      PR2+0
;lights_mikroc.c,274 :: 		INTCON = 0;
	CLRF       INTCON+0
;lights_mikroc.c,275 :: 		T0IE_bit = 1;
	BSF        T0IE_bit+0, 5
;lights_mikroc.c,276 :: 		PEIE_bit = 1;
	BSF        PEIE_bit+0, 6
;lights_mikroc.c,277 :: 		TMR2IE_bit = 1;
	BSF        TMR2IE_bit+0, 1
;lights_mikroc.c,278 :: 		}
	RETURN
; end of _Init

_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0
;lights_mikroc.c,286 :: 		void interrupt (void)
;lights_mikroc.c,297 :: 		if (T0IF_bit && T0IE_bit)
	BTFSS      T0IF_bit+0, 2
	GOTO       L_interrupt13
	BTFSS      T0IE_bit+0, 5
	GOTO       L_interrupt13
L__interrupt42:
;lights_mikroc.c,299 :: 		T0IF_bit = 0;
	BCF        T0IF_bit+0, 2
;lights_mikroc.c,300 :: 		cCounter++;
	INCF       interrupt_cCounter_L0+0, 1
;lights_mikroc.c,302 :: 		cPosition = m_cPosition;    // Position of brightness for first LED
	MOVF       _m_cPosition+0, 0
	MOVWF      interrupt_cPosition_L0+0
;lights_mikroc.c,304 :: 		i = NUMBER_OF_LEDS;         // Loop on all LEDS
	MOVLW      8
	MOVWF      interrupt_i_L0+0
;lights_mikroc.c,305 :: 		cLedsMask = 0x01;
	MOVLW      1
	MOVWF      interrupt_cLedsMask_L0+0
;lights_mikroc.c,307 :: 		do
L_interrupt14:
;lights_mikroc.c,313 :: 		if (cCounter > Brightness[cPosition & TABLE_MASK])  PORTLEDS &= ~cLedsMask;
	MOVLW      7
	ANDWF      interrupt_cPosition_L0+0, 0
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      _Brightness+0
	ADDWF      R0+0, 1
	MOVLW      hi_addr(_Brightness+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R1+0
	MOVF       interrupt_cCounter_L0+0, 0
	SUBWF      R1+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt17
	COMF       interrupt_cLedsMask_L0+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      PORTC+0, 1
	GOTO       L_interrupt18
L_interrupt17:
;lights_mikroc.c,314 :: 		else                                                PORTLEDS |=  cLedsMask;
	MOVF       interrupt_cLedsMask_L0+0, 0
	IORWF      PORTC+0, 1
L_interrupt18:
;lights_mikroc.c,316 :: 		cLedsMask <<= 1;            // Make mask for next LED
	RLF        interrupt_cLedsMask_L0+0, 1
	BCF        interrupt_cLedsMask_L0+0, 0
;lights_mikroc.c,317 :: 		cPosition += m_cDirection;  // Take next position of brightness
	MOVF       _m_cDirection+0, 0
	ADDWF      interrupt_cPosition_L0+0, 1
;lights_mikroc.c,320 :: 		} while (--i);
	DECF       interrupt_i_L0+0, 1
	MOVF       interrupt_i_L0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_interrupt14
;lights_mikroc.c,322 :: 		cCounter &= 0x1F;               // PWM is 5-bit, msb are zeroed
	MOVLW      31
	ANDWF      interrupt_cCounter_L0+0, 1
;lights_mikroc.c,323 :: 		}
L_interrupt13:
;lights_mikroc.c,330 :: 		if (TMR2IF_bit)
	BTFSS      TMR2IF_bit+0, 1
	GOTO       L_interrupt19
;lights_mikroc.c,332 :: 		TMR2IF_bit = 0;
	BCF        TMR2IF_bit+0, 1
;lights_mikroc.c,333 :: 		OS_Timer();
	CALL       _OS_Timer+0
;lights_mikroc.c,334 :: 		}
L_interrupt19:
;lights_mikroc.c,336 :: 		}
L__interrupt43:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_Task_Rolling:
;lights_mikroc.c,351 :: 		void Task_Rolling (void)
;lights_mikroc.c,355 :: 		for (;;)
L_Task_Rolling20:
;lights_mikroc.c,357 :: 		cDelay = 0;
	CLRF       Task_Rolling_cDelay_L0+0
;lights_mikroc.c,358 :: 		while (cDelay++ <= m_cSpeed) OS_Delay(1);   // Wait delay according current
L_Task_Rolling23:
	MOVF       Task_Rolling_cDelay_L0+0, 0
	MOVWF      R1+0
	INCF       Task_Rolling_cDelay_L0+0, 1
	MOVF       R1+0, 0
	SUBWF      _m_cSpeed+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_Task_Rolling24
	MOVLW      1
	MOVWF      FARG__OS_InitDelay_Delay+0
	MOVLW      0
	MOVWF      FARG__OS_InitDelay_Delay+1
	CALL       __OS_InitDelay+0
	MOVLW      $+7
	MOVWF      __fsr+0
	MOVLW      hi_addr($+5)
	CALL       _OS_SchedRetPoint+0
	RETURN
	NOP
	NOP
	GOTO       L_Task_Rolling23
L_Task_Rolling24:
;lights_mikroc.c,360 :: 		m_cPosition ++;                             // Change brightness position
	INCF       _m_cPosition+0, 1
;lights_mikroc.c,361 :: 		}
	GOTO       L_Task_Rolling20
;lights_mikroc.c,362 :: 		}
	RETURN
; end of _Task_Rolling

_Task_Button:
;lights_mikroc.c,375 :: 		void Task_Button (void)
;lights_mikroc.c,377 :: 		for (;;)
L_Task_Button25:
;lights_mikroc.c,382 :: 		do
L_Task_Button28:
;lights_mikroc.c,384 :: 		OS_Cond_Wait(!pin_BUTTON);
	MOVLW      $+7
	MOVWF      __fsr+0
	MOVLW      hi_addr($+32773)
	BCF        __pclath+0, 0
	CALL       _OS_SchedRetPoint+0
	RETURN
	NOP
	NOP
	BTFSC      PORTB+0, 0
	GOTO       L__Task_Button44
	BSF        3, 3
	GOTO       L__Task_Button45
L__Task_Button44:
	BCF        3, 3
L__Task_Button45:
	MOVLW      0
	BTFSC      3, 3
	MOVLW      1
	MOVWF      FARG__OS_CheckEvent_bEvent+0
	CALL       __OS_CheckEvent+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_Task_Button31
	RETURN
L_Task_Button31:
;lights_mikroc.c,385 :: 		OS_Delay(40 ms);                // 40 ms for debounce
	MOVLW      40
	MOVWF      FARG__OS_InitDelay_Delay+0
	MOVLW      0
	MOVWF      FARG__OS_InitDelay_Delay+1
	CALL       __OS_InitDelay+0
	MOVLW      $+7
	MOVWF      __fsr+0
	MOVLW      hi_addr($+5)
	CALL       _OS_SchedRetPoint+0
	RETURN
	NOP
	NOP
;lights_mikroc.c,386 :: 		} while (pin_BUTTON);
	BTFSC      PORTB+0, 0
	GOTO       L_Task_Button28
;lights_mikroc.c,392 :: 		m_cDirection = -m_cDirection;
	MOVF       _m_cDirection+0, 0
	SUBLW      0
	MOVWF      _m_cDirection+0
;lights_mikroc.c,397 :: 		do
L_Task_Button32:
;lights_mikroc.c,399 :: 		OS_Cond_Wait(pin_BUTTON);
	MOVLW      $+7
	MOVWF      __fsr+0
	MOVLW      hi_addr($+32773)
	BCF        __pclath+0, 0
	CALL       _OS_SchedRetPoint+0
	RETURN
	NOP
	NOP
	MOVLW      0
	BTFSC      PORTB+0, 0
	MOVLW      1
	MOVWF      FARG__OS_CheckEvent_bEvent+0
	CALL       __OS_CheckEvent+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_Task_Button35
	RETURN
L_Task_Button35:
;lights_mikroc.c,400 :: 		OS_Delay(40 ms);                // 40 ms for debounce
	MOVLW      40
	MOVWF      FARG__OS_InitDelay_Delay+0
	MOVLW      0
	MOVWF      FARG__OS_InitDelay_Delay+1
	CALL       __OS_InitDelay+0
	MOVLW      $+7
	MOVWF      __fsr+0
	MOVLW      hi_addr($+5)
	CALL       _OS_SchedRetPoint+0
	RETURN
	NOP
	NOP
;lights_mikroc.c,401 :: 		} while (!pin_BUTTON);
	BTFSS      PORTB+0, 0
	GOTO       L_Task_Button32
;lights_mikroc.c,403 :: 		}
	GOTO       L_Task_Button25
;lights_mikroc.c,404 :: 		}
	RETURN
; end of _Task_Button

_Task_SetSpeed:
;lights_mikroc.c,416 :: 		void Task_SetSpeed (void)
;lights_mikroc.c,418 :: 		for (;;)
L_Task_SetSpeed36:
;lights_mikroc.c,420 :: 		ADCON0 &= ~0x38;            // Set AD channel 0
	MOVLW      199
	ANDWF      ADCON0+0, 1
;lights_mikroc.c,422 :: 		GO_bit = 1;                 // Run conversion
	BSF        GO_bit+0, 2
;lights_mikroc.c,423 :: 		OS_Cond_Wait(!NOT_DONE_bit);// Wait for conversion complete
	MOVLW      $+7
	MOVWF      __fsr+0
	MOVLW      hi_addr($+32773)
	BCF        __pclath+0, 0
	CALL       _OS_SchedRetPoint+0
	RETURN
	NOP
	NOP
	BTFSC      NOT_DONE_bit+0, 2
	GOTO       L__Task_SetSpeed46
	BSF        3, 3
	GOTO       L__Task_SetSpeed47
L__Task_SetSpeed46:
	BCF        3, 3
L__Task_SetSpeed47:
	MOVLW      0
	BTFSC      3, 3
	MOVLW      1
	MOVWF      FARG__OS_CheckEvent_bEvent+0
	CALL       __OS_CheckEvent+0
	MOVF       R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_Task_SetSpeed39
	RETURN
L_Task_SetSpeed39:
;lights_mikroc.c,425 :: 		m_cSpeed = ADRESH;          // Set new speed value
	MOVF       ADRESH+0, 0
	MOVWF      _m_cSpeed+0
;lights_mikroc.c,427 :: 		OS_Delay(100 ms);
	MOVLW      100
	MOVWF      FARG__OS_InitDelay_Delay+0
	MOVLW      0
	MOVWF      FARG__OS_InitDelay_Delay+1
	CALL       __OS_InitDelay+0
	MOVLW      $+7
	MOVWF      __fsr+0
	MOVLW      hi_addr($+5)
	CALL       _OS_SchedRetPoint+0
	RETURN
	NOP
	NOP
;lights_mikroc.c,428 :: 		}
	GOTO       L_Task_SetSpeed36
;lights_mikroc.c,429 :: 		}
	RETURN
; end of _Task_SetSpeed
